﻿using System;
using System.Windows.Input;

namespace Hitsuji.Framework.Commands
{
    public class DirectCommand : ICommand
    {
        #region ▼デリゲート

        public delegate bool CanExecuteDelegate(object parameter);
        //protected delegate void ExecuteDelegate();

        #endregion ▲デリゲート


        #region ▼プロパティ

        public CanExecuteDelegate canExecuteDelegate_;
        public Action<object> executeDelegate_;

        #endregion ▲プロパティ


        #region ICommand メンバ

        public bool CanExecute(object parameter)
        {
            if (canExecuteDelegate_ != null)
            {
                return canExecuteDelegate_(parameter);
            }
            else
            {
                return false;
            }
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            if (executeDelegate_ != null)
            {
                executeDelegate_(parameter);
            }
        }

        #endregion
    }
}
