﻿using System.Collections.Generic;
using System.Windows;

namespace Hitsuji.Framework.ViewModels
{
    public class ViewModelCollection
    {
        //制御
        private ViewModelCollection(){}

        //コレクション取得
        private static Dictionary<string, AViewModel> ViewModelDictionary;
        public static Dictionary<string, AViewModel> getInstance()
        {
            if (ViewModelDictionary == null)
            {
                ViewModelDictionary = new Dictionary<string, AViewModel>();
            }
            return ViewModelDictionary;
        }

        /// <summary>
        /// ビューモデルの取得を試みる。
        /// 当該ビューモデルが存在しない場合は新規に登録する。
        /// </summary>
        /// <param name="v">ビューインスタンス（New）</param>
        /// <param name="vm">ビューモデルインスタンス（New）</param>
        /// <returns></returns>
        public static AViewModel getViewModelFromCollection(FrameworkElement v, AViewModel vm)
        {
            AViewModel avm = null;
            if (ViewModelCollection.getInstance().TryGetValue(vm.GetType().Name, out avm))
            {
                avm = ViewModelCollection.getInstance()[vm.GetType().Name];
            }
            else
            {
                avm = ViewModelFactory.createViewModel(v, vm, ViewModelCollection.getInstance());
            }
            return avm;
        }

    }
}
