﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;

namespace Hitsuji.Nengajou.Controls
{
    public class HComboBox : ComboBox
    {
        private Dictionary<string, string> ItemsSourceDictionary_;
        public Dictionary<string, string> ItemsSourceDictionary
        {
            get { return ItemsSourceDictionary_; }
            set
            {
                ItemsSourceDictionary_ = value;
                foreach (KeyValuePair<string, string> kvp in value)
                {
                    this.Items.Add(kvp.Value);
                }
            }
        }

        public string getSelectedItemKey()
        {
            if (this.SelectedItem != null ||
                ItemsSourceDictionary == null ||
                ItemsSourceDictionary.Count <= 0)
                return "";
            foreach (KeyValuePair<string, string> kvp in this.ItemsSourceDictionary)
            {
                if (this.SelectedItem.ToString().Equals(kvp.Value))
                {
                    return kvp.Key;
                }
            }
            return "";
        }
    }
}
