﻿using System;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using Hitsuji.Framework.Date;
using System.Drawing;

namespace Hitsuji.Nengajou.Models.DataBases
{
    public class TableFactory
    {
        public static void createMyPersonalInfoTable()
        {
            try
            {
                XDocument doc = new XDocument(
                                new XElement(PersonalInfoTable.DataSetName,
                                    new XElement(PersonalInfoTable.DataTableName,
                                        new XElement(PersonalInfoTable.Id, "1"),
                                        new XElement(PersonalInfoTable.Enable, "True"),
                                        new XElement(PersonalInfoTable.GroupKey, "1"),
                                        new XElement(PersonalInfoTable.PNoPre1, "１"),
                                        new XElement(PersonalInfoTable.PNoPre2, "２"),
                                        new XElement(PersonalInfoTable.PNoPre3, "３"),
                                        new XElement(PersonalInfoTable.PNoPost1, "４"),
                                        new XElement(PersonalInfoTable.PNoPost2, "５"),
                                        new XElement(PersonalInfoTable.PNoPost3, "６"),
                                        new XElement(PersonalInfoTable.PNoPost4, "７"),
                                        new XElement(PersonalInfoTable.Address1, "じゅうしょ１"),
                                        new XElement(PersonalInfoTable.Address2, ""),
                                        new XElement(PersonalInfoTable.Address3, ""),
                                        new XElement(PersonalInfoTable.Name1, "なまえ１"),
                                        new XElement(PersonalInfoTable.Name2, ""),
                                        new XElement(PersonalInfoTable.Name3, ""),
                                        new XElement(PersonalInfoTable.Name4, ""),
                                        new XElement(PersonalInfoTable.Tel, "０００―１１１１・２２２２")
                                        )
                                    )
                                );
                createFile(doc, FilePathDataBase.getMyPersonalFilePath());
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void createOtherPersonalInfoTable()
        {
            try
            {
                XDocument doc = new XDocument(
                                new XElement(PersonalInfoTable.DataSetName,
                                    new XElement(PersonalInfoTable.DataTableName,
                                        new XElement(PersonalInfoTable.Id, "1"),
                                        new XElement(PersonalInfoTable.Enable, "True"),
                                        new XElement(PersonalInfoTable.GroupKey, "1"),
                                        new XElement(PersonalInfoTable.PNoPre1, "１"),
                                        new XElement(PersonalInfoTable.PNoPre2, "２"),
                                        new XElement(PersonalInfoTable.PNoPre3, "３"),
                                        new XElement(PersonalInfoTable.PNoPost1, "４"),
                                        new XElement(PersonalInfoTable.PNoPost2, "５"),
                                        new XElement(PersonalInfoTable.PNoPost3, "６"),
                                        new XElement(PersonalInfoTable.PNoPost4, "７"),
                                        new XElement(PersonalInfoTable.Address1, "あどれすーーーーーーーーーーーーーーーーーーーー１"),
                                        new XElement(PersonalInfoTable.Address2, "あどれすーーーーーーー２"),
                                        new XElement(PersonalInfoTable.Address3, "あどれすーーーーーーー３"),
                                        new XElement(PersonalInfoTable.Name1, "ねぃむ１"),
                                        new XElement(PersonalInfoTable.Name2, "ねぃむ２"),
                                        new XElement(PersonalInfoTable.Name3, "ねぃむ３"),
                                        new XElement(PersonalInfoTable.Name4, "ねぃむ４"),
                                        new XElement(PersonalInfoTable.NPF1, "様"),
                                        new XElement(PersonalInfoTable.NPF2, "様方"),
                                        new XElement(PersonalInfoTable.NPF3, "殿"),
                                        new XElement(PersonalInfoTable.NPF4, "さん"),
                                        new XElement(PersonalInfoTable.SenderKey, "1"),
                                        new XElement(PersonalInfoTable.ReseiverLayoutKey, "1")
                                        )
                                    )
                                );
                createFile(doc, FilePathDataBase.getOtherPersonalFilePath());
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void createGroupInfoTable()
        {
            try
            {
                XDocument doc = new XDocument(
                                new XElement(GroupInfoTable.DataSetName,
                                    new XElement(GroupInfoTable.DataTableName,
                                        new XElement(GroupInfoTable.Id, "1"),
                                        new XElement(GroupInfoTable.Enable, "True"),
                                        new XElement(GroupInfoTable.Name, "ぐるーぷ１")
                                        )
                                    )
                                );
                createFile(doc, FilePathDataBase.getGroupFilePath());
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void createYearInfoTable()
        {
            try
            {
                XDocument doc = new XDocument(
                                new XElement(YearInfoTable.DataSetName,
                                    new XElement(YearInfoTable.DataTableName,
                                        new XElement(YearInfoTable.Id, "1"),
                                        new XElement(YearInfoTable.Enable, "True"),
                                        new XElement(YearInfoTable.Value, (DateTime.Today.Year + 1).ToString("0000")),
                                        new XElement(YearInfoTable.Eto, HDateEtoUtil.getEto(DateTime.Today.Year + 1))
                                        )
                                    )
                                );
                createFile(doc, FilePathDataBase.getYearFilePath());
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void createFontFamilyInfoTable()
        {
            try
            {
                XDocument doc = new XDocument(
                                new XElement(FontFamilyInfoTable.DataSetName,
                                    new XElement(FontFamilyInfoTable.DataTableName,
                                        new XElement(FontFamilyInfoTable.Id, "1"),
                                        new XElement(FontFamilyInfoTable.Enable, "True"),
                                        new XElement(FontFamilyInfoTable.Name, "ＭＳ Ｐ明朝")
                                        ),
                                     new XElement(FontFamilyInfoTable.DataTableName,
                                        new XElement(FontFamilyInfoTable.Id, "2"),
                                        new XElement(FontFamilyInfoTable.Enable, "True"),
                                        new XElement(FontFamilyInfoTable.Name, "ＭＳ Ｐゴシック")
                                        )
                                    )
                                );
                createFile(doc, FilePathDataBase.getFontFamilyFilePath());
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void createReseiverLayoutInfoTable()
        {
            try
            {
                XDocument doc = new XDocument(
                                new XElement(ReseiverLayoutInfoTable.DataSetName,
                                    new XElement(ReseiverLayoutInfoTable.DataTableName,
                                        new XElement(ReseiverLayoutInfoTable.Id, "1"),
                                        new XElement(ReseiverLayoutInfoTable.Name, "宛名レイアウト１"),
                                        new XElement(ReseiverLayoutInfoTable.label,
                                            new XElement(ReseiverLayoutInfoTable.label_Name, "LBL_R_ADDR1"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(ReseiverLayoutInfoTable.label_X, "334"),
                                            new XElement(ReseiverLayoutInfoTable.label_Y, "96"),
                                            new XElement(ReseiverLayoutInfoTable.label_Width, "28"),
                                            new XElement(ReseiverLayoutInfoTable.label_Height, "400")
                                            ),
                                        new XElement(ReseiverLayoutInfoTable.label,
                                            new XElement(ReseiverLayoutInfoTable.label_Name, "LBL_R_ADDR2"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(ReseiverLayoutInfoTable.label_X, "308"),
                                            new XElement(ReseiverLayoutInfoTable.label_Y, "96"),
                                            new XElement(ReseiverLayoutInfoTable.label_Width, "28"),
                                            new XElement(ReseiverLayoutInfoTable.label_Height, "400")
                                            ),
                                        new XElement(ReseiverLayoutInfoTable.label,
                                            new XElement(ReseiverLayoutInfoTable.label_Name, "LBL_R_NAME1"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(ReseiverLayoutInfoTable.label_X, "202"),
                                            new XElement(ReseiverLayoutInfoTable.label_Y, "115"),
                                            new XElement(ReseiverLayoutInfoTable.label_Width, "28"),
                                            new XElement(ReseiverLayoutInfoTable.label_Height, "200")
                                            ),
                                        new XElement(ReseiverLayoutInfoTable.label,
                                            new XElement(ReseiverLayoutInfoTable.label_Name, "LBL_R_NPF1"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(ReseiverLayoutInfoTable.label_X, "202"),
                                            new XElement(ReseiverLayoutInfoTable.label_Y, "317"),
                                            new XElement(ReseiverLayoutInfoTable.label_Width, "28"),
                                            new XElement(ReseiverLayoutInfoTable.label_Height, "70")
                                            ),
                                        new XElement(ReseiverLayoutInfoTable.label,
                                            new XElement(ReseiverLayoutInfoTable.label_Name, "LBL_S_ADDR1"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(ReseiverLayoutInfoTable.label_X, "117"),
                                            new XElement(ReseiverLayoutInfoTable.label_Y, "251"),
                                            new XElement(ReseiverLayoutInfoTable.label_Width, "22"),
                                            new XElement(ReseiverLayoutInfoTable.label_Height, "200")
                                            ),
                                        new XElement(ReseiverLayoutInfoTable.label,
                                            new XElement(ReseiverLayoutInfoTable.label_Name, "LBL_S_ADDR2"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(ReseiverLayoutInfoTable.label_X, "97"),
                                            new XElement(ReseiverLayoutInfoTable.label_Y, "251"),
                                            new XElement(ReseiverLayoutInfoTable.label_Width, "22"),
                                            new XElement(ReseiverLayoutInfoTable.label_Height, "200")
                                            ),
                                        new XElement(ReseiverLayoutInfoTable.label,
                                            new XElement(ReseiverLayoutInfoTable.label_Name, "LBL_S_NAME1"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(ReseiverLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(ReseiverLayoutInfoTable.label_X, "56"),
                                            new XElement(ReseiverLayoutInfoTable.label_Y, "270"),
                                            new XElement(ReseiverLayoutInfoTable.label_Width, "22"),
                                            new XElement(ReseiverLayoutInfoTable.label_Height, "200")
                                            )
                                        )
                                    )
                                );
                createFile(doc, FilePathDataBase.getReseiverLayoutFilePath());
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void createIllustLayoutInfoTable()
        {
            try
            {
                XDocument doc = new XDocument(
                                new XElement(IllustLayoutInfoTable.DataSetName,
                                    new XElement(IllustLayoutInfoTable.DataTableName,
                                        new XElement(IllustLayoutInfoTable.Id, "1"),
                                        new XElement(IllustLayoutInfoTable.Year, (DateTime.Today.Year + 1).ToString("0000")),
                                        new XElement(IllustLayoutInfoTable.Name, "イラストレイアウト１"),
                                        new XElement(IllustLayoutInfoTable.illust,
                                            new XElement(IllustLayoutInfoTable.illust_Name, "ILLUST1"),
                                            new XElement(IllustLayoutInfoTable.illust_X, "13"),
                                            new XElement(IllustLayoutInfoTable.illust_Y, "366"),
                                            new XElement(IllustLayoutInfoTable.illust_Width, "300"),
                                            new XElement(IllustLayoutInfoTable.illust_Height, "200"),
                                            new XElement(IllustLayoutInfoTable.illust_Image, FilePathDataBase.IllustFile.Replace("\\", ""))
                                            ),
                                        new XElement(IllustLayoutInfoTable.illust,
                                            new XElement(IllustLayoutInfoTable.illust_Name, "ILLUST2"),
                                            new XElement(IllustLayoutInfoTable.illust_X, "150"),
                                            new XElement(IllustLayoutInfoTable.illust_Y, "173"),
                                            new XElement(IllustLayoutInfoTable.illust_Width, "243"),
                                            new XElement(IllustLayoutInfoTable.illust_Height, "162"),
                                            new XElement(IllustLayoutInfoTable.illust_Image, FilePathDataBase.IllustFile.Replace("\\", ""))
                                            ),
                                        new XElement(IllustLayoutInfoTable.illust,
                                            new XElement(IllustLayoutInfoTable.illust_Name, "ILLUST3"),
                                            new XElement(IllustLayoutInfoTable.illust_X, "7"),
                                            new XElement(IllustLayoutInfoTable.illust_Y, "33"),
                                            new XElement(IllustLayoutInfoTable.illust_Width, "180"),
                                            new XElement(IllustLayoutInfoTable.illust_Height, "120"),
                                            new XElement(IllustLayoutInfoTable.illust_Image, FilePathDataBase.IllustFile.Replace("\\", ""))
                                            ),
                                        new XElement(IllustLayoutInfoTable.label,
                                            new XElement(IllustLayoutInfoTable.label_Name, "LBL_MULTI4"),
                                            new XElement(IllustLayoutInfoTable.label_FontSize, "18"),
                                            new XElement(IllustLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(IllustLayoutInfoTable.label_FontColor, "#FFFFFFFF"),
                                            new XElement(IllustLayoutInfoTable.label_X, "88"),
                                            new XElement(IllustLayoutInfoTable.label_Y, "512"),
                                            new XElement(IllustLayoutInfoTable.label_Width, "172"),
                                            new XElement(IllustLayoutInfoTable.label_Height, "37"),
                                            new XElement(IllustLayoutInfoTable.label_Value, "今年もよろしくね！")
                                            ),
                                        new XElement(IllustLayoutInfoTable.label,
                                            new XElement(IllustLayoutInfoTable.label_Name, "LBL_MULTI3"),
                                            new XElement(IllustLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(IllustLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(IllustLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(IllustLayoutInfoTable.label_X, "6"),
                                            new XElement(IllustLayoutInfoTable.label_Y, "172"),
                                            new XElement(IllustLayoutInfoTable.label_Width, "139"),
                                            new XElement(IllustLayoutInfoTable.label_Height, "171"),
                                            new XElement(IllustLayoutInfoTable.label_Value, new StringBuilder("")
                                                                                                .AppendLine("はひふへほ")
                                                                                                .AppendLine("まみむめも")
                                                                                                .AppendLine("やぁ")
                                                                                                .AppendLine("　ゆぅ")
                                                                                                .AppendLine("　　よぉ・・"))
                                            ),
                                        new XElement(IllustLayoutInfoTable.label,
                                            new XElement(IllustLayoutInfoTable.label_Name, "LBL_MULTI2"),
                                            new XElement(IllustLayoutInfoTable.label_FontSize, "12"),
                                            new XElement(IllustLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(IllustLayoutInfoTable.label_FontColor, "#FF000000"),
                                            new XElement(IllustLayoutInfoTable.label_X, "198"),
                                            new XElement(IllustLayoutInfoTable.label_Y, "45"),
                                            new XElement(IllustLayoutInfoTable.label_Width, "189"),
                                            new XElement(IllustLayoutInfoTable.label_Height, "106"),
                                            new XElement(IllustLayoutInfoTable.label_Value, new StringBuilder("かきくけこ")
                                                                        .AppendLine("　さしすせそ")
                                                                        .AppendLine("　　たちつてと")
                                                                        .AppendLine("　　　なに？　・・・ぬねの"))
                                            ),
                                        new XElement(IllustLayoutInfoTable.label,
                                            new XElement(IllustLayoutInfoTable.label_Name, "LBL_MULTI1"),
                                            new XElement(IllustLayoutInfoTable.label_FontSize, "16"),
                                            new XElement(IllustLayoutInfoTable.label_FontFamily, "ＭＳ Ｐ明朝"),
                                            new XElement(IllustLayoutInfoTable.label_FontColor, "#FF0000FF"),
                                            new XElement(IllustLayoutInfoTable.label_X, "194"),
                                            new XElement(IllustLayoutInfoTable.label_Y, "5"),
                                            new XElement(IllustLayoutInfoTable.label_Width, "192"),
                                            new XElement(IllustLayoutInfoTable.label_Height, "37"),
                                            new XElement(IllustLayoutInfoTable.label_Value, "あいうえおめでとう！！")
                                            )
                                        )
                                    )
                                );
                createFile(doc, FilePathDataBase.getIllustLayoutFilePath());
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void createDefaultIllust()
        {
            try
            {
                var bImage = new Bitmap(300, 200);
                Graphics graph = Graphics.FromImage(bImage);
                graph.Clear(System.Drawing.Color.LightGreen);
                graph.DrawString("No Image !",
                    new Font(new FontFamily("ＭＳ Ｐ明朝"), 40), 
                    System.Drawing.Brushes.Green, 
                    new Point(20, 70));

                bImage.Save(FilePathDataBase.getIllustFileFilePath());
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }



        protected static void createFile(XDocument doc, string Path)
        {
            var writer = new XmlTextWriter(Path, Encoding.UTF8);
            try
            {
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
            finally
            {
                writer.Close();
                writer = null;
                doc = null;
            }
        }

        public static void checkExistAndCreateDirectory(string path)
        {
            try
            {
                if (!Directory.Exists(path))
                {
                    Directory.CreateDirectory(path);
                    System.Threading.Thread.Sleep(150);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public static void checkExistAndCreateTable(string path, Action createTableDelegate)
        {
            try
            {
                if (!File.Exists(path))
                {
                    createTableDelegate();
                    System.Threading.Thread.Sleep(150);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }
    }
}
