﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Hitsuji.Framework.ObserverPattern.Observer;
using Hitsuji.Framework.ObserverPattern.Subject;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Framework.ViewModel;
using Hitsuji.Nengajou.Views;
using Hitsuji.Nengajou.ViewModel;

namespace Hitsuji.Nengajou.ObserverPattern.Observers
{
    public class ReflectUIPostInfoInputViewObserver : IObserver, IReflectUIObserver
    {
        #region IObserver メンバ

        public void doMyRole(ASubject ASubject)
        {
            var vmDictionary = ViewModelCollection.getInstance();
            PrimaryAreaBaseViewModel primaryAreaBaseVM = vmDictionary["PrimaryAreaBaseViewModel"] as PrimaryAreaBaseViewModel;
            PrimaryAreaBaseView primaryAreaBaseV = (PrimaryAreaBaseView)primaryAreaBaseVM.View;

            AViewModel postInfoInputVM = null;
            if (vmDictionary.TryGetValue("PostInputViewModel", out postInfoInputVM))
            {
                postInfoInputVM = ViewModelCollection.getInstance()[postInfoInputVM.GetType().Name];
            }
            else
            {
                postInfoInputVM = ViewModelFactory.createViewModel(new PostInputView(),
                                                                   new PostInputViewModel(),
                                                                   ViewModelCollection.getInstance());
            }

            primaryAreaBaseVM.clearStackPanelItems();
            primaryAreaBaseV.stackPanel1.Children.Add(postInfoInputVM.View);
        }

        #endregion

        #region IReflectUIObserver メンバ

        public void setRefViewModel(AViewModel vm)
        {
            throw new NotImplementedException();
        }

        public void reflectUi(List<Action> dispatchActionList)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
