﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using Hitsuji.Framework.ObserverPattern.Observers;
using Hitsuji.Framework.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;
using Hitsuji.Nengajou.ObserverPattern.Subjects;

namespace Hitsuji.Nengajou.ObserverPattern.Observers
{
    public class UpdateGroupDataSourceObserver : IObserver
    {
        #region IObserver メンバ

        public void doMyRole(ASubject aSubject)
        {
            try
            {
                Subject subject = (Subject)aSubject;
                var info = subject.models["GroupInfoContentModel"] as GroupInfoContentModel;
                var infoList = subject.models["infoList"] as List<IContentModel>;

                XDocument doc = new XDocument();
                XElement rootElem = new XElement(GroupInfoTable.DataSetName);
                GroupInfoContentModel data;
                int maxId = 0;
                //更新処理分（既存データ）
                foreach (GroupInfoContentModel model in infoList as List<IContentModel>)
                {
                    if(string.IsNullOrEmpty(info.Id) ||
                        !info.Id.Equals(model.Id))
                    {
                        data = model;
                    }
                    else
                    {
                        data = info;
                    }
                    
                    rootElem.Add(
                        new XElement(GroupInfoTable.DataTableName,
                            new XElement(GroupInfoTable.Id, data.Id),
                            new XElement(GroupInfoTable.Enable, data.Enable.ToString()),
                            new XElement(GroupInfoTable.Name, data.Name)
                                )
                            );
                    
                    if (maxId < int.Parse(data.Id)) maxId = int.Parse(data.Id);
                }
                //新規登録分
                if (string.IsNullOrEmpty(info.Id))
                {
                    rootElem.Add(
                        new XElement(GroupInfoTable.DataTableName,
                            new XElement(GroupInfoTable.Id, (maxId + 1).ToString()),
                            new XElement(GroupInfoTable.Enable, true.ToString()),
                            new XElement(GroupInfoTable.Name, info.Name)
                                )
                            );
                }

                doc.Add(rootElem);
                
                var writer = new XmlTextWriter(FilePathDataBase.getGroupFilePath(), Encoding.UTF8);
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
                writer.Close();
                doc = null;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        #endregion
    }
}
