﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using Hitsuji.Framework.ObserverPattern.Observers;
using Hitsuji.Framework.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;
using Hitsuji.Nengajou.ObserverPattern.Subjects;

namespace Hitsuji.Nengajou.ObserverPattern.Observers
{
    public class UpdateOtherPersonalDataSourceObserver : IObserver
    {
        #region IObserver メンバ

        public void doMyRole(ASubject aSubject)
        {
            try
            {
                Subject subject = (Subject)aSubject;
                var info = subject.models["OtherPersonalInfoContentModel"] as OtherPersonalInfoContentModel;
                var infoList = subject.models["infoList"] as List<IContentModel>;

                XDocument doc = new XDocument();
                XElement rootElem = new XElement(PersonalInfoTable.DataSetName);
                OtherPersonalInfoContentModel data;
                int maxId = 0;
                //更新処理分（既存データ）
                foreach (OtherPersonalInfoContentModel model in infoList as List<IContentModel>)
                {
                    if (string.IsNullOrEmpty(info.Id) ||
                        !info.Id.Equals(model.Id))
                    {
                        data = model;
                    }
                    else
                    {
                        data = info;
                    }

                    rootElem.Add(
                        new XElement(PersonalInfoTable.DataTableName,
                            new XElement(PersonalInfoTable.Id, data.Id),
                            new XElement(PersonalInfoTable.Enable, data.Enable.ToString()),
                            new XElement(PersonalInfoTable.GroupKey, data.GroupKey),
                            new XElement(PersonalInfoTable.PNoPre1, data.PNoPre1),
                            new XElement(PersonalInfoTable.PNoPre2, data.PNoPre2),
                            new XElement(PersonalInfoTable.PNoPre3, data.PNoPre3),
                            new XElement(PersonalInfoTable.PNoPost1, data.PNoPost1),
                            new XElement(PersonalInfoTable.PNoPost2, data.PNoPost2),
                            new XElement(PersonalInfoTable.PNoPost3, data.PNoPost3),
                            new XElement(PersonalInfoTable.PNoPost4, data.PNoPost4),
                            new XElement(PersonalInfoTable.Address1, data.Address1),
                            new XElement(PersonalInfoTable.Address2, data.Address2),
                            new XElement(PersonalInfoTable.Address3, data.Address3),
                            new XElement(PersonalInfoTable.Name1, data.Name1),
                            new XElement(PersonalInfoTable.Name2, data.Name2),
                            new XElement(PersonalInfoTable.Name3, data.Name3),
                            new XElement(PersonalInfoTable.Name4, data.Name4),
                            new XElement(PersonalInfoTable.NPF1, data.NPF1),
                            new XElement(PersonalInfoTable.NPF2, data.NPF2),
                            new XElement(PersonalInfoTable.NPF3, data.NPF3),
                            new XElement(PersonalInfoTable.NPF4, data.NPF4),
                            new XElement(PersonalInfoTable.SenderKey, data.SenderKey),
                            new XElement(PersonalInfoTable.ReseiverLayoutKey, data.ReseiverLayoutKey)
                                )
                            );

                    if (maxId < int.Parse(data.Id)) maxId = int.Parse(data.Id);
                }
                //新規登録分
                if (string.IsNullOrEmpty(info.Id))
                {
                    rootElem.Add(
                        new XElement(PersonalInfoTable.DataTableName,
                            new XElement(PersonalInfoTable.Id, (maxId + 1).ToString()),
                            new XElement(PersonalInfoTable.Enable, info.Enable.ToString()),
                            new XElement(PersonalInfoTable.GroupKey, info.GroupKey),
                            new XElement(PersonalInfoTable.PNoPre1, info.PNoPre1),
                            new XElement(PersonalInfoTable.PNoPre2, info.PNoPre2),
                            new XElement(PersonalInfoTable.PNoPre3, info.PNoPre3),
                            new XElement(PersonalInfoTable.PNoPost1, info.PNoPost1),
                            new XElement(PersonalInfoTable.PNoPost2, info.PNoPost2),
                            new XElement(PersonalInfoTable.PNoPost3, info.PNoPost3),
                            new XElement(PersonalInfoTable.PNoPost4, info.PNoPost4),
                            new XElement(PersonalInfoTable.Address1, info.Address1),
                            new XElement(PersonalInfoTable.Address2, info.Address2),
                            new XElement(PersonalInfoTable.Address3, info.Address3),
                            new XElement(PersonalInfoTable.Name1, info.Name1),
                            new XElement(PersonalInfoTable.Name2, info.Name2),
                            new XElement(PersonalInfoTable.Name3, info.Name3),
                            new XElement(PersonalInfoTable.Name4, info.Name4),
                            new XElement(PersonalInfoTable.NPF1, info.NPF1),
                            new XElement(PersonalInfoTable.NPF2, info.NPF2),
                            new XElement(PersonalInfoTable.NPF3, info.NPF3),
                            new XElement(PersonalInfoTable.NPF4, info.NPF4),
                            new XElement(PersonalInfoTable.SenderKey, info.SenderKey),
                            new XElement(PersonalInfoTable.ReseiverLayoutKey, info.ReseiverLayoutKey)
                                )
                            );
                }

                doc.Add(rootElem);

                var writer = new XmlTextWriter(FilePathDataBase.getOtherPersonalFilePath(), Encoding.UTF8);
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
                writer.Close();
                doc = null;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        #endregion
    }
}
