﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using Hitsuji.Framework.ObserverPattern.Observers;
using Hitsuji.Framework.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Framework.Date;

namespace Hitsuji.Nengajou.ObserverPattern.Observers
{
    public class UpdateYearDataSourceObserver : IObserver
    {
        #region IObserver メンバ

        public void doMyRole(ASubject aSubject)
        {
            try
            {
                Subject subject = (Subject)aSubject;
                var info = subject.models["YearInfoContentModel"] as YearInfoContentModel;
                var infoList = subject.models["infoList"] as List<IContentModel>;

                XDocument doc = new XDocument();
                XElement rootElem = new XElement(YearInfoTable.DataSetName);
                YearInfoContentModel data;
                int maxId = 0;
                //更新処理分（既存データ）
                foreach (YearInfoContentModel model in infoList as List<IContentModel>)
                {
                    if (string.IsNullOrEmpty(info.Id) ||
                        !info.Id.Equals(model.Id))
                    {
                        data = model;
                    }
                    else
                    {
                        data = info;
                    }

                    rootElem.Add(
                        new XElement(YearInfoTable.DataTableName,
                            new XElement(YearInfoTable.Id, data.Id),
                            new XElement(YearInfoTable.Enable, data.Enable.ToString()),
                            new XElement(YearInfoTable.Value, data.Value),
                            new XElement(YearInfoTable.Eto, HDateEtoUtil.getEto(int.Parse(data.Value)))
                                )
                            );

                    if (maxId < int.Parse(data.Id)) maxId = int.Parse(data.Id);
                }
                //新規登録分
                if (string.IsNullOrEmpty(info.Id))
                {
                    rootElem.Add(
                        new XElement(YearInfoTable.DataTableName,
                            new XElement(YearInfoTable.Id, (maxId + 1).ToString()),
                            new XElement(YearInfoTable.Enable, true.ToString()),
                            new XElement(YearInfoTable.Value, info.Value),
                            new XElement(YearInfoTable.Eto, HDateEtoUtil.getEto(int.Parse(info.Value)))
                                )
                            );
                }

                doc.Add(rootElem);

                var writer = new XmlTextWriter(FilePathDataBase.getYearFilePath(), Encoding.UTF8);
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
                writer.Close();
                doc = null;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        #endregion
    }
}
