﻿using System;
using System.Linq;
using System.Xml.Linq;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;

namespace Hitsuji.Nengajou.ObserverPattern.Subjects
{
    public class GetFontFamilyInfoSubject : Subject
    {
        public bool enableParam = true;

        public void doMyRole()
        {
            try
            {
                //抽出処理開始
                XDocument fontFamilyDoc = XDocument.Load(FilePathDataBase.getFontFamilyFilePath());
                var query = from f in fontFamilyDoc.Descendants(FontFamilyInfoTable.DataTableName)
                            select new
                            {
                                fontId = f.Element(FontFamilyInfoTable.Id),
                                fontEnable = f.Element(FontFamilyInfoTable.Enable),
                                fontName = f.Element(FontFamilyInfoTable.Name)
                            };

                var list = new ContentModelList();
                foreach (var data in query)
                {
                    var fontModel = new FontFamilyInfoContentModel();
                    fontModel.Id = data.fontId.Value;
                    fontModel.Enable = bool.Parse(data.fontEnable.Value);
                    fontModel.FontFamilyName = data.fontName.Value;
                    list.addContentModel(fontModel);
                }

                query = null;
                fontFamilyDoc = null;
                models.Add("infoList", list);

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            notify(this);

        }
    }
}
