﻿using System;
using System.Linq;
using System.Xml.Linq;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;

namespace Hitsuji.Nengajou.ObserverPattern.Subjects
{
    public class GetMyPersonalInfoSubject : Subject
    {
        public bool enableParam = true;

        public void doMyRole()
        {
            try
            {
                //抽出処理開始
                XDocument groupDoc = XDocument.Load(FilePathDataBase.getGroupFilePath());
                XDocument personDoc = XDocument.Load(FilePathDataBase.getMyPersonalFilePath());
                var query = from p in personDoc.Descendants(PersonalInfoTable.DataTableName)
                            join g in groupDoc.Descendants(GroupInfoTable.DataTableName)
                                on (string)p.Element(PersonalInfoTable.GroupKey) equals (string)g.Element(GroupInfoTable.Id)
                            select new
                            {
                                personId = p.Element(PersonalInfoTable.Id),
                                personEnable = p.Element(PersonalInfoTable.Enable),
                                personPrim1 = p.Element(PersonalInfoTable.PNoPre1),
                                personPrim2 = p.Element(PersonalInfoTable.PNoPre2),
                                personPrim3 = p.Element(PersonalInfoTable.PNoPre3),
                                personSeco1 = p.Element(PersonalInfoTable.PNoPost1),
                                personSeco2 = p.Element(PersonalInfoTable.PNoPost2),
                                personSeco3 = p.Element(PersonalInfoTable.PNoPost3),
                                personSeco4 = p.Element(PersonalInfoTable.PNoPost4),
                                personAddress1 = p.Element(PersonalInfoTable.Address1),
                                personAddress2 = p.Element(PersonalInfoTable.Address2),
                                personAddress3 = p.Element(PersonalInfoTable.Address3),
                                personName1 = p.Element(PersonalInfoTable.Name1),
                                personName2 = p.Element(PersonalInfoTable.Name2),
                                personName3 = p.Element(PersonalInfoTable.Name3),
                                personName4 = p.Element(PersonalInfoTable.Name4),
                                groupId = p.Element(PersonalInfoTable.GroupKey),
                                groupName = g.Element(GroupInfoTable.Name),
                                personTel = p.Element(PersonalInfoTable.Tel)
                            };

                var list = new ContentModelList();
                foreach (var data in query)
                {
                    var personContentModel = new MyPersonalInfoContentModel();
                    personContentModel.Id = data.personId.Value;
                    personContentModel.Enable = bool.Parse(data.personEnable.Value);
                    personContentModel.PNoPre1 = data.personPrim1.Value;
                    personContentModel.PNoPre2 = data.personPrim2.Value;
                    personContentModel.PNoPre3 = data.personPrim3.Value;
                    personContentModel.PNoPost1 = data.personSeco1.Value;
                    personContentModel.PNoPost2 = data.personSeco2.Value;
                    personContentModel.PNoPost3 = data.personSeco3.Value;
                    personContentModel.PNoPost4 = data.personSeco4.Value;
                    personContentModel.GroupKey = data.groupId.Value;
                    personContentModel.GroupName = data.groupName.Value;
                    personContentModel.Address1 = data.personAddress1.Value;
                    personContentModel.Address2 = data.personAddress2.Value;
                    personContentModel.Address3 = data.personAddress3.Value;
                    personContentModel.Name1 = data.personName1.Value;
                    personContentModel.Name2 = data.personName2.Value;
                    personContentModel.Name3 = data.personName3.Value;
                    personContentModel.Name4 = data.personName4.Value;
                    personContentModel.Tel = data.personTel.Value;
                    list.addContentModel(personContentModel);
                }

                query = null;
                personDoc = null;
                groupDoc = null;
                models.Add("infoList", list);

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            notify(this);

        }
    }
}
