﻿using System;
using System.Linq;
using System.Xml.Linq;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;

namespace Hitsuji.Nengajou.ObserverPattern.Subjects
{
    public class GetYearInfoSubject : Subject
    {
        public bool enableParam = true;

        public void doMyRole()
        {
            try
            {
                //抽出処理開始
                XDocument yearDoc = XDocument.Load(FilePathDataBase.getYearFilePath());
                var query = from y in yearDoc.Descendants(YearInfoTable.DataTableName)
                            select new
                            {
                                yearId = y.Element(YearInfoTable.Id),
                                yearEnable = y.Element(YearInfoTable.Enable),
                                yearValue = y.Element(YearInfoTable.Value),
                                yearEto = y.Element(YearInfoTable.Eto)
                            };

                var list = new ContentModelList();
                foreach (var data in query)
                {
                    var yearModel = new YearInfoContentModel();
                    yearModel.Id = data.yearId.Value;
                    yearModel.Enable = bool.Parse(data.yearEnable.Value);
                    yearModel.Value = data.yearValue.Value;
                    yearModel.Eto = data.yearEto.Value;
                    list.addContentModel(yearModel);
                }

                query = null;
                yearDoc = null;
                models.Add("infoList", list);

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            notify(this);

        }
    }
}
