﻿using System;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.ObserverPattern.Observers;
using Hitsuji.Nengajou.ObserverPattern.Subjects;

namespace Hitsuji.Nengajou.ViewModels
{
    public class CreatePrintLayoutViewModel : AViewModel
    {
        public CreatePrintLayoutInfoContentModel CreatePrintLayoutInfo
        {
            get;
            set;
        }

        public CreatePrintLayoutViewModel()
        {
            this.CreatePrintLayoutInfo = ContentModelFactory.createPrintLayoutContentModel();
            this.CreatePrintLayoutInfo.canExeDelegate_ = this.canExecuteMethod;
            this.CreatePrintLayoutInfo.exeDelegate_ = this.executeMethod;
        }

        public void onReseiverLayoutForPrintButtonClicked()
        {
            try
            {
                var getSubject = new GetReseiverLayoutInfoForPrintoutSubject();
                var createObserver = new CreateReseiverLayoutForPrintObserver();
                getSubject.addObserver(createObserver);
                getSubject.doMyRole();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public void onIllustLayoutForPrintButtonClicked()
        {
            try
            {
                var getSubject = new GetIllustLayoutInfoSubject();
                var createObserver = new CreateIllustLayoutForPrintObserver();
                getSubject.yearParam = this.CreatePrintLayoutInfo.LayoutYear;
                getSubject.addObserver(createObserver);
                getSubject.doMyRole();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        //コマンド関連
        public bool canExecuteMethod()
        {
            return !string.IsNullOrEmpty(this.CreatePrintLayoutInfo.LayoutYear);
        }

        public void executeMethod()
        {
            //
        }
    }
}
