﻿using System;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.ObserverPattern.Observers;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Views;

namespace Hitsuji.Nengajou.ViewModels
{
    public class GroupInputViewModel : AViewModel
    {

        private IContentModel GroupContentInfo_;
        public IContentModel GroupContentInfo
        {
            get { return GroupContentInfo_; }
            set { GroupContentInfo_ = value; }
        }


        public GroupInputViewModel()
        {
            GroupContentInfo_ = ContentModelFactory.createGroupContentModel();
            (GroupContentInfo_ as GroupInfoContentModel).canExeDelegate_ = canExecute;
            (GroupContentInfo_ as GroupInfoContentModel).exeDelegate_ = execute;

        }

        //コマンド CanExecute
        public bool canExecute()
        {
            return !string.IsNullOrEmpty((GroupContentInfo as GroupInfoContentModel).Name);
        }

        //コマンド execute
        protected void execute()
        {
            try
            {
                var getGroupInfosSubject = new GetGroupInfoSubject();
                var updateGroupDataSourceFileObserver = new UpdateGroupDataSourceObserver();
                getGroupInfosSubject.models.Add(this.GroupContentInfo.GetType().Name, this.GroupContentInfo);
                getGroupInfosSubject.addObserver(updateGroupDataSourceFileObserver);
                getGroupInfosSubject.doMyRole();

                //強制的にビュー更新
                var primaryMenuVM = ViewModelManager.getInstance()["PrimaryMenuViewModel"] as PrimaryMenuViewModel;
                primaryMenuVM.onGroupMenuClicked();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }
    }
}
