﻿using System;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.ObserverPattern.Observers;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Views;

namespace Hitsuji.Nengajou.ViewModels
{
    public class YearInputViewModel : AViewModel
    {

        private IContentModel YearContentInfo_;
        public IContentModel YearContentInfo
        {
            get { return YearContentInfo_; }
            set { YearContentInfo_ = value; }
        }

        public YearInputViewModel()
        {
            YearContentInfo_ = ContentModelFactory.createYearContentModel();
            (YearContentInfo_ as YearInfoContentModel).canExeDelegate_ = this.canExecute;
            (YearContentInfo_ as YearInfoContentModel).exeDelegate_ = this.execute;
        }

        //コマンド CanExecute
        public bool canExecute()
        {
            int result = 0;
            return (!string.IsNullOrEmpty((YearContentInfo as YearInfoContentModel).Value) &&
                     int.TryParse((YearContentInfo as YearInfoContentModel).Value, out result) &&
                     int.Parse((YearContentInfo as YearInfoContentModel).Value) > 2000 &&
                     int.Parse((YearContentInfo as YearInfoContentModel).Value) < 3000);
        }

        //コマンド execute
        protected void execute()
        {
            try
            {
                var getYearInfosSubject = new GetYearInfoSubject();
                var updateYearDataSourceFileObserver = new UpdateYearDataSourceObserver();
                getYearInfosSubject.models.Add(this.YearContentInfo.GetType().Name, this.YearContentInfo);
                getYearInfosSubject.addObserver(updateYearDataSourceFileObserver);
                getYearInfosSubject.doMyRole();

                //強制的にビュー更新
                var primaryMenuVM = ViewModelManager.getInstance()["PrimaryMenuViewModel"] as PrimaryMenuViewModel;
                primaryMenuVM.onYearMenuClicked();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }
    }
}
